//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DarkGray
#property indicator_color6  Gold
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_level1  0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern string TimeFrame           = "Current time frame";
extern double Period1             =  32;
extern double Period2             =   5;
extern double Period3             =   5;
extern int    Price               = PRICE_CLOSE;
extern bool   alertsOn            = false;
extern bool   alertsOnZeroCross   = true;
extern bool   alertsOnSignalCross = true;
extern bool   alertsOnCurrent     = true;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = false;
extern bool   alertsEmail         = false;


double di[];
double dihuu[];
double dihud[];
double dihdd[];
double dihdu[];
double signal[];
double slope[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,dihuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,dihud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,dihdd); SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3,dihdu); SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4,di);
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,slope);
   
      indicatorFileName = WindowExpertName();
      calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
      returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
      timeFrame         = stringToTimeFrame(TimeFrame);
   
      IndicatorShortName(timeFrameToString(timeFrame)+" Blau ergodic divergence indicator ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+","+DoubleToStr(Period3,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double trend[][2];
#define _signal 0
#define _zeroli 1
 
int start()
{
   int i,r,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { dihuu[0] = MathMin(limit+1,Bars-1); return(0); }
         if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(i=limit, r=Bars-i-1; i >= 0; i--,r++)
      {
         double priceDiff = iMA(NULL,0,1,0,MODE_SMA,Price,i)-iMA(NULL,0,1,0,MODE_SMA,Price,i+1);
            di[i] = 100.0*iEma(iEma( priceDiff ,Period1,i,0),Period2,i,1);
            dihuu[i] = EMPTY_VALUE;
            dihud[i] = EMPTY_VALUE;
            dihdd[i] = EMPTY_VALUE;
            dihdu[i] = EMPTY_VALUE;
            signal[i] = iEma(di[i],Period3,i,2);

            //
            //
            //
            //
            //
                           
            trend[r][_zeroli] = trend[r-1][_zeroli];
            trend[r][_signal] = trend[r-1][_signal];
            slope[i] = slope[i+1];
               if (di[i] > signal[i]) trend[r][_signal] =  1;
               if (di[i] < signal[i]) trend[r][_signal] = -1;
               if (di[i] > 0)         trend[r][_zeroli] =  1;
               if (di[i] < 0)         trend[r][_zeroli] = -1;
               if (di[i] > di[i+1])  slope[i] =  1;
               if (di[i] < di[i+1])  slope[i] = -1;
               if (di[i]>0)
               if (slope[i]==1)
                     dihuu[i] = di[i];
               else  dihud[i] = di[i];
               if (di[i]<0)
               if (slope[i]==1)
                     dihdu[i] = di[i];
               else  dihdd[i] = di[i];
      }
      manageAlerts();
      return(0);
   }

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         di[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Price,alertsOn,alertsOnZeroCross,alertsOnSignalCross,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,4,y);
         signal[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Price,alertsOn,alertsOnZeroCross,alertsOnSignalCross,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,5,y);
         slope[i]  = slope[i+1];
         dihuu[i]  = EMPTY_VALUE;
         dihud[i]  = EMPTY_VALUE;
         dihdd[i]  = EMPTY_VALUE;
         dihdu[i]  = EMPTY_VALUE;
         trend[r][_zeroli] = trend[r-1][_zeroli];
         trend[r][_signal] = trend[r-1][_signal];
            if (di[i] > signal[i]) trend[r][_signal] =  1;
            if (di[i] < signal[i]) trend[r][_signal] = -1;
            if (di[i] > 0)         trend[r][_zeroli] =  1;
            if (di[i] < 0)         trend[r][_zeroli] = -1;
            if (di[i] > di[i+1])  slope[i] =  1;
            if (di[i] < di[i+1])  slope[i] = -1;
            if (di[i]>0)
            if (slope[i]==1)
                  dihuu[i] = di[i];
            else  dihud[i] = di[i];
            if (di[i]<0)
            if (slope[i]==1)
                  dihdu[i] = di[i];
            else  dihdd[i] = di[i];
   }
   return(0);
         
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][5];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-whichBar-1;
      
      //
      //
      //
      //
      //
            
      if (alertsOnZeroCross && trend[whichBar][_zeroli] != trend[whichBar-1][_zeroli])
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (trend[whichBar][_zeroli] ==  1) doAlert(time1,mess1," Blau DI crossed zero line up");
            if (trend[whichBar][_zeroli] == -1) doAlert(time1,mess1," Blau DI crossed zero line down");
      }
      if (alertsOnSignalCross && trend[whichBar][_signal] != trend[whichBar-1][_signal])
      {
         static datetime time2 = 0;
         static string   mess2 = "";
            if (trend[whichBar][_signal] ==  1) doAlert(time2,mess2," Blau DI crossed signal line up");
            if (trend[whichBar][_signal] == -1) doAlert(time2,mess2," Blau DI crossed signal line down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" Blau ergodic DI",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf){
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}